package org.noote.libs.virtualpad;

public class Virtual5DPad extends VirtualTouchPad {
	
	protected boolean _bCenterPressed = false;
	protected boolean _bUpPressed = false;
	protected boolean _bDownPressed = false;
	protected boolean _bRightPressed = false;
	protected boolean _bLeftPressed = false;
	
	public Virtual5DPad()
	{
		super(VIRTUAL_5PADS);
	}

	@Override
	public void setTouchEvent(int x, int y, boolean state, boolean moved)
	{
		if(isInWorkSpace(x, y))
		{
			_bNewEvent = true;
			_iState = state;
			_fPosition_X = ((float)(_iMax_X-x)/(float)(_iMax_X-_iMin_X));
			_fPosition_Y = 1.0f-((float)(_iMax_Y-y)/(float)(_iMax_Y-_iMin_Y));
			_fPosition_X -=0.5f;
			_fPosition_Y -=0.5f;
			_fPosition_X *=2.0f;
			_fPosition_Y *=2.0f;

			_checkVirtual5Pads();
		}
	}
	
	protected void _checkVirtual5Pads()
	{
		_bCenterPressed = false;
		_bUpPressed = false;
		_bDownPressed = false;
		_bRightPressed = false;
		_bLeftPressed = false;
		
		if(_iState == false) return;

		float fLimitMin = -0.33f;
		float fLimitMax = 0.33f;
		
		if(_fPosition_X>=fLimitMin && _fPosition_X<=fLimitMax
			&& _fPosition_Y>=fLimitMin && _fPosition_Y<=fLimitMax)
			_bCenterPressed = true;
		else if(_fPosition_X>fLimitMax && _fPosition_Y>=fLimitMin && _fPosition_Y<=fLimitMax)
			_bLeftPressed = true; 
		else if(_fPosition_X<fLimitMax && _fPosition_Y>=fLimitMin && _fPosition_Y<=fLimitMax)
			_bRightPressed = true; 
		else if(_fPosition_X>=fLimitMin && _fPosition_X<=fLimitMax && _fPosition_Y>fLimitMax)
			_bDownPressed = true; 
		else if(_fPosition_X>=fLimitMin && _fPosition_X<=fLimitMax && _fPosition_Y<fLimitMin)
			_bUpPressed = true; 
	}
	
	public boolean getButtonUp(){return _bUpPressed;}
	public boolean getButtonDown(){return _bDownPressed;}
	public boolean getButtonRight(){return _bRightPressed;}
	public boolean getButtonLeft(){return _bLeftPressed;}
	public boolean getButtonCenter(){return _bCenterPressed;}
}
