package org.noote.libs.virtualpad;

public class VirtualTouchPad {
	public static final int VIRTUAL_ANALOGIC = 0;
	public static final int VIRTUAL_5PADS = 1;
	public static final int VIRTUAL_9PADS = 2;
	
	protected int _iMin_X=0, _iMin_Y=0;
	protected int _iMax_X=0, _iMax_Y=0;

	protected float _fPosition_X=0, _fPosition_Y=0;
	protected boolean _iState = false;	

	protected boolean _bNewEvent = false;
	protected float _fOld_Position_X=0, _fOld_Position_Y=0;
	protected boolean _iOld_State = false;
	
	protected boolean _bUpPressed = false;
	protected boolean _bDownPressed = false;
	protected boolean _bRightPressed = false;
	protected boolean _bLeftPressed = false;
	protected boolean _bUpRightPressed = false;
	protected boolean _bUpLeftPressed = false;
	protected boolean _bDownRightPressed = false;
	protected boolean _bDownLeftPressed = false;
	protected boolean _bCenterPressed = false;
	
	protected int _iVirtualType = VIRTUAL_ANALOGIC;
	
	public VirtualTouchPad()
	{		
	}
	public VirtualTouchPad(int iType)
	{
		_iVirtualType = iType;
	}

	public int getType()
	{
		return _iVirtualType;
	}
	
	public void setWorkSpace(int x, int y, int sx, int sy)
	{
		_iMin_X=x;
		_iMin_Y=y;
		_iMax_X=x+sx;
		_iMax_Y=y+sy;
	}

	public boolean isInWorkSpace(int x, int y)
	{
		if(x>=_iMin_X && x<=_iMax_X && y>=_iMin_Y && y<=_iMax_Y)
			return true;
			
		return false;
	}
	public void setTouchEvent(int x, int y, boolean state, boolean moved)
	{
		if(isInWorkSpace(x, y))
		{
			_bNewEvent = true;
			_iState = state;
			_fPosition_X = ((float)(_iMax_X-x)/(float)(_iMax_X-_iMin_X));
			_fPosition_Y = 1.0f-((float)(_iMax_Y-y)/(float)(_iMax_Y-_iMin_Y));
			_fPosition_X -=0.5f;
			_fPosition_Y -=0.5f;
			_fPosition_X *=2.0f;
			_fPosition_Y *=2.0f;
		}
	}
	
	public boolean haveNewEvent(){return _bNewEvent;}
	public void resetNewEvent(){_bNewEvent = false;}
	
	public float getX(){return _fPosition_X;}
	public float getY(){return _fPosition_Y;}
	public float getTouch(){return _iState?1.0f:0.0f;}
}
